using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace CurrencySample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 48);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(544, 480);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(576, 550);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridDataBoundGrid1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			SetDataTableIntoGrid();

			//register new cell type
			this.gridDataBoundGrid1.Model.CellModels.Add("QCurrency",
							new GridCurrencyCellModel(this.gridDataBoundGrid1.Model));
			
			//format the grid
			GridStyleInfo style = this.gridDataBoundGrid1.Binder.InternalColumns["$$$1"].StyleInfo;
			style.CellValueType = typeof(double);
			//style.CellType = "Currency";
			style.CellType = "QCurrency";
			style.Format = "$#,###.00;($#,###.00)";


			this.gridDataBoundGrid1.ActivateCurrentCellBehavior = GridCellActivateAction.DblClickOnCell;
		}

		private void SetDataTableIntoGrid()
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 1000;

			for(int i = 0; i < nCols; i++)
			{
				if(i % 2 == 0)
					dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
				else
					dt.Columns.Add(new DataColumn(string.Format("$$${0}", i), typeof(double)));
			}

			Random r = new Random();
			double dSign =  -1;
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				
				for(int j = 0; j < nCols; j++)
				{
					if(j % 2 == 0)
						dr[j] = string.Format("row{0} col{1}", i, j);
					else
						dr[j] =  (dSign * r.NextDouble() * 100000000);
				}
				dSign = dSign *  (-1);
				dt.Rows.Add(dr);
			}

			this.gridDataBoundGrid1.DataSource = dt;
		}
	}
}
